DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Member Functions | Protected Attributes | Private Attributes | List of all members
DiMonoPixelTemplate< T > Class Template Reference

Template class to handle monochrome pixel data. More...

Inheritance diagram for DiMonoPixelTemplate< T >:

## Public Member Functions
| DiMonoPixelTemplate (const unsigned long count)
| constructor More...
| DiMonoPixelTemplate (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor More...
| DiMonoPixelTemplate (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor More...
virtual | ~DiMonoPixelTemplate ()
| destructor
EP_Representation | getRepresentation () const
| get integer representation More...
const void * | getData () const
| get pointer to internal pixel data More...
void * | getDataPtr ()
| get pointer to internal pixel data More...
void * | getDataArrayPtr ()
| get reference to pointer to internal pixel data. More...
int | getMinMaxValues (double &min, double &max) const
| get minimum and maximum pixel values More...
int | getMinMaxWindow (const int idx, double &center, double &width)
| get automatically computed min-max window More...
virtual int | getRoiWindow (const unsigned long left_pos, const unsigned long top_pos, const unsigned long width, const unsigned long height, const unsigned long columns, const unsigned long rows, const unsigned long frame, double &voiCenter, double &voiWidth)
| get automatically computed Region of Interest (ROI) window More...
int | getHistogramWindow (const double thresh, double &center, double &width)
| get automatically computed histogram window More...
Public Member Functions inherited from DiMonoPixel
| DiMonoPixel (const unsigned long count)
| constructor More...
| DiMonoPixel (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor More...
| DiMonoPixel (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor More...
virtual | ~DiMonoPixel ()
| destructor
int | getPlanes () const
| get number of planes More...
unsigned int | getBits () const
| get number of bits per pixel More...
double | getAbsMinimum () const
| get absolute minimum pixel value. More...
double | getAbsMaximum () const
| get absolute maximum pixel value. More...
double | getAbsMaxRange () const
| get absolute pixel range More...
const char * | getModalityLutExplanation () const
| get modality LUT explanation string More...
DiMonoModality * | addReferenceToModality ()
| add a reference to the internally managed modality transform object More...
int | isPotentiallySigned () const
| check whether pixel data is 'potentially' signed. More...
Public Member Functions inherited from DiPixel
| DiPixel (const unsigned long count, const unsigned long inputCount=0)
| constructor More...
virtual | ~DiPixel ()
| destructor
unsigned long | getCount () const
| get number of pixels More...
unsigned long | getInputCount () const
| get number of pixels stored in the 'PixelData' element More...
Public Member Functions inherited from DiPixelRepresentationTemplate< T >
| DiPixelRepresentationTemplate ()
| default constructor
virtual | ~DiPixelRepresentationTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not More...

## Protected Member Functions
| DiMonoPixelTemplate (const DiPixel *pixel, DiMonoModality *modality)
| constructor More...
| DiMonoPixelTemplate (const DiMonoPixel *pixel, const unsigned long count)
| constructor More...
void | determineMinMax (T minvalue=0, T maxvalue=0, const int mode=0x1)
| determine minimum and maximum pixel values More...
Protected Member Functions inherited from DiMonoPixel
| DiMonoPixel (const DiPixel *pixel, DiMonoModality *modality)
| constructor More...
| DiMonoPixel (const DiMonoPixel *pixel, const unsigned long count)
| constructor More...

## Protected Attributes
T * | Data
| pointer to pixel data
Protected Attributes inherited from DiMonoPixel
DiMonoModality * | Modality
| pointer to modality transform object
Protected Attributes inherited from DiPixel
unsigned long | Count
| number of pixels
unsigned long | InputCount
| number of pixels in the input buffer

## Private Attributes
T | MinValue [2]
| minimum pixel values (0 = global, 1 = ignoring global)
T | MaxValue [2]
| maximum pixel values

## Detailed Description

### template<class T>
class DiMonoPixelTemplate< T >

Template class to handle monochrome pixel data.

## Constructor & Destructor Documentation

## ◆ DiMonoPixelTemplate() [1/5]

template<class T >

DiMonoPixelTemplate< T >::DiMonoPixelTemplate | ( | const unsigned long | count | ) |
| inline

constructor

Parameters

  count | number of pixels

References DiPixel::Count, DiMonoPixelTemplate< T >::Data, DiMonoPixelTemplate< T >::MaxValue, and DiMonoPixelTemplate< T >::MinValue.

## ◆ DiMonoPixelTemplate() [2/5]

template<class T >

DiMonoPixelTemplate< T >::DiMonoPixelTemplate | ( | const DiInputPixel * | pixel,
|  | DiMonoModality * | modality
| ) |  |
| inline

constructor

Parameters

  pixel | pointer to input pixel data
  modality | pointer to object managing modality transform

References DiMonoPixelTemplate< T >::MaxValue, and DiMonoPixelTemplate< T >::MinValue.

## ◆ DiMonoPixelTemplate() [3/5]

template<class T >

DiMonoPixelTemplate< T >::DiMonoPixelTemplate | ( | DiMonoOutputPixel * | pixel,
|  | DiMonoModality * | modality
| ) |  |
| inline

constructor

Parameters

  pixel | pointer to output pixel data used for intermediate representation
  modality | pointer to object managing modality transform

## ◆ DiMonoPixelTemplate() [4/5]

template<class T >

DiMonoPixelTemplate< T >::DiMonoPixelTemplate | ( | const DiPixel * | pixel,
|  | DiMonoModality * | modality
| ) |  |
| inline protected

constructor

Parameters

  pixel | pointer to intermediate pixel data (not necessarily monochrome)
  modality | pointer to object managing modality transform

References DiMonoPixelTemplate< T >::MaxValue, and DiMonoPixelTemplate< T >::MinValue.

## ◆ DiMonoPixelTemplate() [5/5]

template<class T >

DiMonoPixelTemplate< T >::DiMonoPixelTemplate | ( | const DiMonoPixel * | pixel,
|  | const unsigned long | count
| ) |  |
| inline protected

constructor

Parameters

  pixel | pointer to intermediate monochrome pixel data
  count | number of pixels

References DiMonoPixelTemplate< T >::MaxValue, and DiMonoPixelTemplate< T >::MinValue.

## Member Function Documentation

## ◆ determineMinMax()

template<class T >

void DiMonoPixelTemplate< T >::determineMinMax | ( | T | minvalue = `0`,
|  | T | maxvalue = `0`,
|  | const int | mode = `0x1`
| ) |  |
| inline protected

determine minimum and maximum pixel values

Parameters

  minvalue | starting global minimum value (0 = invalid)
  maxvalue | starting global maximum value (0 = invalid)
  mode | calculate global min/max if 0x1 bit is set (default), calculate next min/max if 0x2 bit is set

References DiMonoPixelTemplate< T >::Data.

Referenced by DiMonoPixelTemplate< T >::getMinMaxWindow().

## ◆ getData()

template<class T >

const void* DiMonoPixelTemplate< T >::getData | ( |  | ) | const
| inline virtual

get pointer to internal pixel data

Returns
  pointer to pixel data

Implements DiPixel.

## ◆ getDataArrayPtr()

template<class T >

void* DiMonoPixelTemplate< T >::getDataArrayPtr | ( |  | ) |
| inline virtual

get reference to pointer to internal pixel data.

The returned array points to the (single) image plane. The behaviour of this method is, therefore, identical for both monochrome and color images.

Returns
  reference to pointer to pixel data

Implements DiPixel.

## ◆ getDataPtr()

template<class T >

void* DiMonoPixelTemplate< T >::getDataPtr | ( |  | ) |
| inline virtual

get pointer to internal pixel data

Returns
  pointer to pixel data

Implements DiPixel.

## ◆ getHistogramWindow()

template<class T >

int DiMonoPixelTemplate< T >::getHistogramWindow | ( | const double | thresh,
|  | double & | center,
|  | double & | width
| ) |  |
| inline virtual

get automatically computed histogram window

Parameters

  thresh | ignore certain percentage of pixels at lower and upper boundaries
  center | reference to storage area for window center value
  width | reference to storage area for window width value

Returns
  status, true if successful, false otherwise

Implements DiMonoPixel.

References DiMonoPixelTemplate< T >::Data, DiMonoPixelTemplate< T >::MaxValue, and DiMonoPixelTemplate< T >::MinValue.

## ◆ getMinMaxValues()

template<class T >

int DiMonoPixelTemplate< T >::getMinMaxValues | ( | double & | min,
|  | double & | max
| ) |  | const
| inline virtual

get minimum and maximum pixel values

Parameters

  min | reference to storage area for minimum pixel value
  max | reference to storage area for maximum pixel value

Returns
  status, true if successful, false otherwise

Implements DiMonoPixel.

References DiMonoPixelTemplate< T >::MaxValue, and DiMonoPixelTemplate< T >::MinValue.

## ◆ getMinMaxWindow()

template<class T >

int DiMonoPixelTemplate< T >::getMinMaxWindow | ( | const int | idx,
|  | double & | center,
|  | double & | width
| ) |  |
| inline virtual

get automatically computed min-max window

Parameters

  idx | ignore global min/max pixel values if > 0
  center | reference to storage area for window center value
  width | reference to storage area for window width value

Returns
  status, true if successful, false otherwise

Implements DiMonoPixel.

References DiMonoPixelTemplate< T >::determineMinMax(), DiMonoPixelTemplate< T >::MaxValue, and DiMonoPixelTemplate< T >::MinValue.

## ◆ getRepresentation()

template<class T >

EP_Representation DiMonoPixelTemplate< T >::getRepresentation | ( |  | ) | const
| inline virtual

get integer representation

Returns
  integer representation of the internally stored pixel data

Reimplemented from DiPixelRepresentationTemplate< T >.

References DiPixelRepresentationTemplate< T >::getRepresentation().

## ◆ getRoiWindow()

template<class T >

virtual int DiMonoPixelTemplate< T >::getRoiWindow | ( | const unsigned long | left_pos,
|  | const unsigned long | top_pos,
|  | const unsigned long | width,
|  | const unsigned long | height,
|  | const unsigned long | columns,
|  | const unsigned long | rows,
|  | const unsigned long | frame,
|  | double & | voiCenter,
|  | double & | voiWidth
| ) |  |
| inline virtual

get automatically computed Region of Interest (ROI) window

Parameters

  left_pos | x-coordinate of the top left-hand corner of the ROI (starting from 0)
  top_pos | y-coordinate of the top left-hand corner of the ROI (starting from 0)
  width | width in pixels of the rectangular ROI (minimum: 1)
  height | height in pixels of the rectangular ROI (minimum: 1)
  columns | number of columns (width) of the associated image
  rows | number of rows (height) of the associated image
  frame | index of the frame to be used for the calculation
  voiCenter | reference to storage area for window center value
  voiWidth | reference to storage area for window width value

Returns
  status, true if successful, false otherwise

Implements DiMonoPixel.

References DiMonoPixelTemplate< T >::Data.

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/dimopxt.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1